
{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        #12, CP0, CP1, CP2, CP3      'servo control pins
        #8,  FP0, FP1, FP2, FP3      'servo feedback pins
        #0, Servo0, Servo1, Servo2, Servo3  'servo names
        sync = 0                     'engineering
VAR
  byte  Cog
  word  commanded, actual     'angles
  long random      
  byte  DisplayServo, currentservo 'used to display all angles
  word  rcount                'counts random positionings
  word  Cmnded[4]            
  word theservo
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FourPly"
  
PUB main              
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)

 ' cog := FBS.start(0,0, CP1,FP1, 0,0, 0,0)   'specify pin numbers 
  cog := FBS.start(cp0,fp0, CP1,FP1, cp2,fp2, cp3,fp3)   'specify pin numbers   
  pst.str(string("started position cog: "))       '0,0 pin numbers says no servo
  pst.dec(cog)
  pst.newline
  waitcnt(clkfreq/2+cnt)          'allow time for it to start    
  dira[sync] := 1                  'scope probe

  repeat theservo from 0 to 3     'constant pulse width
    FBS.width(theservo, 1550)
  repeat 20
    showangles
    pst.newline
    waitcnt(clkfreq/100+cnt)
  repeat theservo from 0 to 3    
    fbs.width(theservo, 1500)
     
  repeat theservo from 0 to 3     'full scale changes
    pst.dec(theservo)
    pst.char(" ")
    MySet(theservo, 180)
    pst.dec(WaitSet(theservo))
    pst.char(" ")
    Myset(theservo, 1)
    pst.dec(WaitSet(theservo))
    pst.char(" ")
    MySet(theservo, 359)
     pst.dec(WaitSet(theservo))
    pst.char(" ")
    myset(theservo, 1)
    pst.dec(WaitSet(theservo))
    pst.newline


  rcount := 0                                  'all four with random movements
  repeat while rcount < 250
     repeat currentservo from 0 to 3
       if fbs.checkdone(currentservo) == 0     'issue command to whichever is done
          pst.newline
          pst.dec(currentservo)               'number
          pst.str(string("  Prev Cmnd:  "))
          pst.dec(cmnded[currentservo])
          pst.str(string("  Actuals:  "))
          showangles 
          ?random
          commanded := || random           'drop sign bit
          commanded := (commanded // 360)    'range 0..359        
          myset(currentservo,commanded)
          cmnded[currentservo] := commanded
          pst.str(string(" New Cmnd: "))
          pst.dec(commanded)       
          pst.str(string("   "))
          pst.dec(rcount++)
           
  pst.str(string("  Done"))   
  repeat                                'stop here        
  
pub MySet(servo, degrees)
     outa[sync] := 1                 'sync
     FBS.SetPos(servo,degrees)   'set position
     outa[sync] := 0

pub WaitSet(servo)            
     repeat while FBS.CheckDone(servo) <> 0    'await completion
     waitcnt(clkfreq/100+cnt)     
     return FBS.getpos(servo)

pub showangles
    repeat displayservo from 0 to 3
      pst.str(string("  Servo"))
      pst.dec(displayservo)
      pst.char(" ")
      pst.dec(FBS.getpos(displayservo))
      pst.str(string("   "))
                   